# @axelarjs

![build & test workflow](https://github.com/axelarnetwork/axelarjs/actions/workflows/test.yml/badge.svg)

Axelar Network foundations for Javascript/Typescript application development

:building_construction: under construction :building_construction:

Packages:

| package                        | description                                                                 |
| ------------------------------ | --------------------------------------------------------------------------- |
| 🎨 [ui](/packages/ui)          | shared UI component library (react + tailwindcss)                           |
| 📡 [api](/packages/api)        | api client for axelar restful services                                      |
| ⚙️ [core](/packages//core)     | core utilities, types, constants and data-structures                        |
| 🗚 [proto](/packages/proto)     | generated types from axelar-core protobuf files                             |
| 🐬 [evm](/packages//evm)       | evm-specific tooling based on [viem](https://github.com/wagmi-dev/viem)     |
| ⚛️ [cosmos](/packages//cosmos) | cosmos-specific tooling based on [cosmjs](https://github.com/cosmos/cosmjs) |
| 🔧 [utils](/packages/utils)    | framework-agnostic utilities and helper functions                           |

Apps:

| app                         | description                     |
| --------------------------- | ------------------------------- |
| 🎼 [maestro](/apps/maestro) | Interchain Token Service Portal |
