import { NEXT_PUBLIC_VERCEL_URL } from "./env";

export const TERMS_OF_USE_PARAGRAPHS = `
Please read these Terms of Use (these “Terms”) carefully because they govern your use of the website located at  ${NEXT_PUBLIC_VERCEL_URL} (the “Site”).  The Site, made available by Axelar Foundation (the “Foundation” or “Site Operator” or “we” or “us”), acts as an information hub for and a front-end to various open-sourced protocols that operate using blockchain technology, including the Maestro protocol (the “Protocol”).  To make these Terms easier to read, the Site and our services are collectively called the “Interface.”

NOTICE ON PROHIBITED USE – RESTRICTED PERSONS: THE INTERFACE AND ANY RELATED SERVICES ARE NOT OFFERED TO AND MAY NOT BE USED BY:

PERSONS OR ENTITIES WHO RESIDE IN, ARE CITIZENS OF, ARE LOCATED IN, ARE INCORPORATED IN, OR HAVE A REGISTERED OFFICE IN ANY RESTRICTED TERRITORY, AS DEFINED BELOW (EACH SUCH PERSON OR ENTITY FROM A RESTRICTED TERRITORY, A “RESTRICTED PERSON”).

WE DO NOT MAKE EXCEPTIONS. THEREFORE, IF YOU ARE A RESTRICTED PERSON, THEN DO NOT ATTEMPT TO USE THE INTERFACE OR ANY RELATED SERVICES. USE OF A VIRTUAL PRIVATE NETWORK (“VPN”) OR ANY OTHER SIMILAR MEANS INTENDED TO CIRCUMVENT THE RESTRICTIONS SET FORTH HEREIN IS PROHIBITED.

WHEN YOU AGREE TO THESE TERMS, YOU ARE AGREEING TO RESOLVE ANY DISPUTE BETWEEN YOU AND US THROUGH BINDING, INDIVIDUAL ARBITRATION RATHER THAN IN COURT. PLEASE REVIEW CAREFULLY THE DISPUTE RESOLUTION PROVISIONS BELOW FOR DETAILS REGARDING ARBITRATION.HOWEVER, IF YOU ARE A RESIDENT OF A JURISDICTION WHERE APPLICABLE LAW PROHIBITS ARBITRATION OF DISPUTES, THE AGREEMENT TO ARBITRATE WILL NOT APPLY TO YOU BUT CAYMAN ISLAND LAW WILL CONTINUE TO APPLY.

All goods or services provided through the Protocol are provided on an “as is,” “as available” basis. The Protocol is constantly under active development, and it is currently undergoing its “beta” testing phase, meaning that while the core features of the Protocol have been implemented, undetected bugs, errors, and vulnerabilities may remain undiscovered until this phase of testing is complete.

The Protocol may now or in the future contain undetected errors, bugs, or vulnerabilities. It is possible that we will not detect errors in the Protocol or the underlying technology until after code has been fully released for external or internal use. Any errors, bugs, vulnerabilities, or other design defects discovered in the Protocol’s code after release may result in a negative experience for the Protocol’s users.

Users are solely responsible for safeguarding their private keys and keeping such keys confidential from others. Because a private key, or a combination of private keys, is necessary to control and dispose of the digital assets stored in the user’s digital asset wallet, the loss of one or more of a user’s private keys associated with her, his or its digital asset wallet storing the user’s digital assets will result in the permanent, irreversible loss of the user’s digital assets. Moreover, any third party that gains access to one or more of a user’s private keys, including by gaining access to login credentials of a hosted wallet service a user uses, will be able to misappropriate a user’s digital assets. The Foundation and its affiliates will never ask a user for her, his or its private key address and a user should never share them with someone the user does not know and trust.

Transactions in digital assets performed via the Protocol may be irreversible, and, accordingly, losses due to fraudulent or accidental transactions may not be recoverable. Once a transaction has been verified and recorded in a block that is added to the blockchain, an incorrect transfer or a theft of digital assets generally will not be reversible. If a party is able to hack a user’s account and initiate a transaction, the user may not be capable of receiving compensation for any such transfer or theft. If there is an error and a transaction occurs with the wrong account, the Foundation has no obligation, duty or liability to assist the user in seeking a corrective transaction (if at all available) whatsoever, and such funds will generally be permanently and irreversibly lost. The Foundation will not be able to revert or otherwise recover incorrectly transferred digital assets, and shall bear no responsibility for any such losses. The user is solely responsible for providing the Protocol with accurate information with respect to the destination digital asset wallet intended for the receipt of the user’s digital assets. If information provided by a user proves incorrect, or if the recipient wallet address is not compatible with the intended digital asset, and as a result, the digital assets are not delivered to the intended destination digital asset wallet or lost, the Foundation will not have any liability to the user for the loss of such digital assets suffered by the user.

You may use the Interface only if you are at least 18 years of age (or such other minimum age at which you can provide consent to data processing under the laws of your territory), and not otherwise barred from using the Interface under applicable law. In order to protect the integrity of the Interface, we reserve the right, at any time, in our sole discretion, to block access to the Interface from certain IP addresses and unique device identifiers. For the purposes of the Terms, “Restricted Territory” means of Algeria, Bangladesh, Bolivia, Belarus, Burundi, Burma (Myanmar), Cote D'Ivoire (Ivory Coast), Crimea and Sevastopol, Cuba, Democratic Republic of Congo, Ecuador, Iran, Iraq, Liberia, Libya, Mali, Morocco, Nepal, North Korea, Somalia, Sudan, Syria, Venezuela, Yemen, Zimbabwe or any other country to which Canada, Panama, the United States, the United Kingdom or the European Union embargoes goods or imposes similar sanctions.

You agree not to do any of the following: 
    • Use, display, mirror or frame the Interface or any individual element within the Interface, The Site Operator’s name, any Site Operator trademark, logo or other proprietary information, or the layout and design of any page or form contained on a page, without the Site Operator’s express written consent; 
    • Access, tamper with, or use non-public areas of the Interface, Site Operator’s computer systems, or the technical delivery systems of Site Operator’s providers; 
    • Attempt to probe, scan or test the vulnerability of any Site Operator system or network or breach any security or authentication measures; 
    • Avoid, bypass, remove, deactivate, impair, descramble or otherwise circumvent any technological measure implemented by the Site Operator or any of the Site Operator’s providers or any other third party (including another user) to protect the Interface; 
    • Attempt to access or search the Interface or download content from the Interface using any engine, software, tool, agent, device or mechanism (including spiders, robots, crawlers, data mining tools or the like) other than the software and/or search agents provided by the Site Operator or other generally available third-party web browsers; 
    • Use any meta tags or other hidden text or metadata utilizing Site Operator trademark, logo URL or product name without the Site Operator’s express written consent; 
    • Use the Interface, or any portion thereof, for any commercial purpose or for the benefit of any third party or in any manner not permitted by these Terms; 
    • Forge any TCP/IP packet header or any part of the header information in any email or newsgroup posting, or in any way use the Interface to send altered, deceptive or false source-identifying information; 
    • Attempt to decipher, decompile, disassemble or reverse engineer any of the software used to provide the Interface; 
    • Interfere with, or attempt to interfere with, the access of any user, host or network, including, without limitation, sending a virus, overloading, flooding, spamming, or mail-bombing the Interface; 
    • Collect or store any personally identifiable information from the Interface from other users of the Interface without their express permission; 
    • Impersonate or misrepresent your affiliation with any person or entity; 
    • Violate any applicable law, rule, or regulation concerning the integrity of trading markets, including (but not limited to) the manipulative tactics commonly known as spoofing and wash trading;
    • Violate any applicable law or regulation; or
    • Encourage or enable any other individual to do any of the foregoing.

The Site Operator is not obligated to monitor access to or use of the Interface or to review or edit any content. However, we have the right to do so for the purpose of operating the Interface, to ensure compliance with these Terms and to comply with applicable law or other legal requirements. We reserve the right, but are not obligated, to remove or disable access to any content at any time and without notice, including, but not limited to, if we, at our sole discretion, consider it objectionable or in violation of these Terms.  We have the right to investigate violations of these Terms or conduct that affects the Interface. We may also consult and cooperate with law enforcement authorities to prosecute users who violate the law.

THE USER’S USE OF THE PROTOCOL AND ANY RELATED SERVICES IS AT THE USER’S SOLE RISK. THE PROTOCOL IS PROVIDED ON AN “AS IS'' AND “AS AVAILABLE” BASIS. 

THE PROTOCOL AND ITS ASSOCIATED SMART CONTRACTS ARE INTANGIBLE PIECES OF SOFTWARE CODE THAT EXIST ONLY BY VIRTUE OF THEIR DEPLOYMENT AND INTERACTIONS WITH THIRD PARTIES THAT ARE MAINTAINED IN THE APPLICABLE BLOCKCHAIN NETWORK. ANY INTERACTIONS, TRANSFERS OF VALUE, CALCULATIONS AND OTHER ACTIVITIES THAT MIGHT OCCUR IN CONNECTION WITH THE PROTOCOL OCCURS SOLELY ON THE DECENTRALIZED LEDGER AND SMART CONTRACT ENVIRONMENT WITHIN SUCH BLOCKCHAIN NETWORK. THE FOUNDATION DOES NOT GUARANTEE THAT SUCH SMART CONTRACTS OR BLOCKCHAIN NETWORKS WILL OPERATE AS INTENDED OR AT ALL. IN ADDITION, SUCH BLOCKCHAIN NETWORKS ARE BEYOND THE CONTROL OF THE FOUNDATION, AND THE FOUNDATION WILL HAVE NO LIABILITY WITH RESPECT TO ANY BLOCKCHAIN NETWORKS, INCLUDING FORKS, TECHNICAL NODE ISSUES OR ANY OTHER ISSUES INVOLVING FUNDS OR ASSET LOSSES AS A RESULT. THE FOUNDATION WILL NOT BE RESPONSIBLE OR LIABLE TO ANY USER FOR ANY LOSS AND TAKES NO RESPONSIBILITY FOR, AND WILL NOT BE LIABLE FOR, ANY USE OF THE PROTOCOL OR ANY ASSOCIATED SMART CONTRACTS OR BLOCKCHAIN NETWORKS INCLUDING ANY LOSSES, DAMAGES OR CLAIMS ARISING FROM: (I) USER ERROR SUCH AS FORGOTTEN PASSWORDS, PRIVATE KEYS, INCORRECTLY CONSTRUCTED TRANSACTIONS, OR MISTYPED, ERRONEOUS OR INCOMPATIBLE ADDRESSES; (II) SERVER FAILURE OR DATA LOSS; (III) CORRUPTED CRYPTOCURRENCY WALLET FILES; (IV) UNAUTHORIZED ACCESS TO APPLICATIONS; OR (V) ANY UNAUTHORIZED THIRD PARTY ACTIVITIES, INCLUDING WITHOUT LIMITATION THE USE OF VIRUSES, PHISHING, BRUTEFORCING OR OTHER MEANS OF ATTACK AGAINST THE SERVICE OR CRYPTO ASSETS.

TO THE FULLEST EXTENT LEGALLY PERMISSIBLE, THE FOUNDATION DOES NOT MAKE (AND EXPLICITLY DISCLAIMS) ANY AND ALL REPRESENTATIONS OR WARRANTIES OF ANY KIND RELATED TO THE PROTOCOL, WHETHER EXPRESS, IMPLIED, OR STATUTORY, INCLUDING (WITHOUT LIMITATION) THE WARRANTIES OF MERCHANTABILITY, NON- INFRINGEMENT, AND FITNESS FOR A PARTICULAR PURPOSE. NEITHER THE FOUNDATION NOR ANY PERSON ASSOCIATED WITH THE FOUNDATION MAKES ANY WARRANTY OR REPRESENTATION WITH RESPECT TO THE COMPLETENESS, SECURITY, RELIABILITY, QUALITY, ACCURACY, OR AVAILABILITY OF THE PROTOCOL OR ANY RELATED SERVICES. TO THE FULLEST EXTENT PROVIDED BY LAW, IN NO EVENT WILL THE FOUNDATION, OR ANY AFFILIATES, OR THEIR LICENSORS, SERVICE PROVIDERS, EMPLOYEES, AGENTS, OFFICERS, OR DIRECTORS BE LIABLE FOR DAMAGES OF ANY KIND, UNDER ANY LEGAL THEORY, ARISING OUT OF OR IN CONNECTION WITH THE USER'S USE, OR INABILITY TO USE, THE PROTOCOL, ANY WEBSITES LINKED TO IT, ANY CONTENT ON THE FOUNDATION’S WEBSITE OR SUCH OTHER WEBSITES, INCLUDING ANY DIRECT, INDIRECT, SPECIAL, INCIDENTAL, CONSEQUENTIAL, OR PUNITIVE DAMAGES, INCLUDING BUT NOT LIMITED TO, PERSONAL INJURY, PAIN AND SUFFERING, EMOTIONAL DISTRESS, LOSS OF REVENUE, LOSS OF PROFITS, LOSS OF BUSINESS OR ANTICIPATED SAVINGS, LOSS OF USE, LOSS OF GOODWILL, LOSS OF DATA, AND WHETHER CAUSED BY TORT (INCLUDING NEGLIGENCE), BREACH OF CONTRACT, OR OTHERWISE, EVEN IF FORESEEABLE. THIS DISCLAIMER OF LIABILITY EXTENDS TO ANY AND ALL DAMAGES CAUSED BY ANY THIRD PARTY (INCLUDING, WITHOUT LIMITATION, THOSE CAUSED BY FRAUD, DECEIT, OR MANIPULATION), WHETHER OR NOT A PARTICIPANT, OR ANY FAILURE, EXPLOIT, OR VULNERABILITY OF THE PROTOCOL, THE USER’S WEB3 UTILITIES, OR THE UNDERLYING BLOCKCHAINS OR RELATED BLOCKCHAIN FUNCTIONALITIES. TO THE FULLEST EXTENT PROVIDED BY LAW, IN NO EVENT WILL THE COLLECTIVE LIABILITY OF THE FOUNDATION AND ITS SUBSIDIARIES AND AFFILIATES, AND THEIR LICENSORS, SERVICE PROVIDERS, EMPLOYEES, AGENTS, OFFICERS, AND DIRECTORS, TO ANY PARTY (REGARDLESS OF THE FORM OF ACTION, WHETHER IN CONTRACT, TORT, OR OTHERWISE) EXCEED THE GREATER OF $100 OR THE AMOUNT THE FOUNDATION RECEIVED FROM THE USER FOR THE USE OF THE PROTOCOL IN THE LAST SIX MONTHS OUT OF WHICH LIABILITY AROSE. THE FOREGOING DOES NOT AFFECT ANY LIABILITY THAT CANNOT BE EXCLUDED OR LIMITED UNDER APPLICABLE LAW.

Any dispute, claim, suit, action, cause of action, demand or proceeding arising out or in connection with these Terms (any of the foregoing occurrences, a “Dispute”), or the breach, termination or invalidity thereof shall first be endeavored to be settled through amicable negotiations in good faith by you and us. If you and us cannot agree how to resolve such Dispute within thirty (30) consecutive calendar days after the date a notice with respect to such Dispute is received by the other party, then either you or we may, as appropriate, commence an arbitration proceeding. Such Dispute shall subsequently (and exclusively) be submitted to three arbitrators. The nomination of the arbitrators and the rules of arbitration shall be in accordance with the Rules of Arbitration of Cayman Islands. The seat of the arbitral tribunal shall be Grand Cayman, Cayman Islands. Language of the proceedings shall be English. The arbitral award is final and binding upon the parties. The arbitration fees will be borne by the losing party except otherwise awarded by the arbitral tribunal. The parties undertake to carry out the arbitral award in accordance with the modalities of said reward. Any Dispute that is not or cannot be subject to arbitration will be resolved by the courts of Cayman Islands governed by the laws of the Cayman Islands.
`
  // trim whitespace
  .trim()
  .split("\n")
  // sanitize paragraphs
  .map((p) => p.trim())
  // remove empty paragraphs
  .filter((p) => p.length);
